The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::Twang Class Reference

STK enhanced plucked string class. More...

`#include <Twang.h>`

Inheritance diagram for stk::Twang:

List of all members.

## Public Member Functions
| Twang (StkFloat lowestFrequency=50.0)
| Class constructor, taking the lowest desired playing frequency.
void | clear (void)
| Reset and clear all internal state.
void | setLowestFrequency (StkFloat frequency)
| Set the delayline parameters to allow frequencies as low as specified.
void | setFrequency (StkFloat frequency)
| Set the delayline parameters for a particular frequency.
void | setPluckPosition (StkFloat position)
| Set the pluck or "excitation" position along the string (0.0 - 1.0).
void | setLoopGain (StkFloat loopGain)
| Set the nominal loop gain.
void | setLoopFilter (std::vector< StkFloat > coefficients)
| Set the loop filter coefficients.
StkFloat | lastOut (void)
| Return an StkFrames reference to the last output sample frame.
StkFloat | tick (StkFloat input)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the `iFrames` object as inputs to the class and write outputs to the `oFrames` object.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the effect and write outputs to the `oFrames` object.

## Detailed Description

STK enhanced plucked string class.

This class implements an enhanced plucked-string physical model, a la Jaffe-Smith, Smith, Karjalainen and others. It includes a comb filter to simulate pluck position. The tick() function takes an input sample, which is added to the delayline input. This can be used to implement commuted synthesis (if the input samples are derived from the impulse response of a body filter) and/or feedback (as in an electric guitar model).

This is a digital waveguide model, making its use possibly subject to patents held by Stanford University, Yamaha, and others.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Member Function Documentation

void stk::Twang::setLoopGain | ( | StkFloat | loopGain | ) |

Set the nominal loop gain.

The actual loop gain is based on the value set with this function, but scaled slightly according to the frequency. Higher frequency settings have greater loop gains because of high-frequency loop-filter roll-off.

void stk::Twang::setLoopFilter | ( | std::vector< StkFloat > | coefficients | ) |

Set the loop filter coefficients.

The loop filter can be any arbitrary FIR filter. By default, the coefficients are set for a first-order lowpass filter with coefficients b = [0.5 0.5].

StkFloat stk::Twang::lastOut | ( | void |  | ) | `[inline]`

Return an StkFrames reference to the last output sample frame.

Return the last computed output value.

    00074 { return lastOutput_; };

StkFrames & stk::Twang::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline]`

Take a channel of the `iFrames` object as inputs to the class and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

    00123 {
    00124 #if defined(_STK_DEBUG_)
    00125   if ( channel >= frames.channels() ) {
    00126     oStream_ << "Twang::tick(): channel and StkFrames arguments are incompatible!";
    00127     handleError( StkError::FUNCTION_ARGUMENT );
    00128   }
    00129 #endif
    00130
    00131   StkFloat *samples = &frames[channel];
    00132   unsigned int hop = frames.channels();
    00133   for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00134     *samples = tick( *samples );
    00135
    00136   return frames;
    00137 }

StkFrames & stk::Twang::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0` |
| ) |  |  | `[inline]`

Take a channel of the `iFrames` object as inputs to the effect and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

    00140 {
    00141 #if defined(_STK_DEBUG_)
    00142   if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
    00143     oStream_ << "Twang::tick(): channel and StkFrames arguments are incompatible!";
    00144     handleError( StkError::FUNCTION_ARGUMENT );
    00145   }
    00146 #endif
    00147
    00148   StkFloat *iSamples = &iFrames[iChannel];
    00149   StkFloat *oSamples = &oFrames[oChannel];
    00150   unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
    00151   for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop )
    00152     *oSamples = tick( *iSamples );
    00153
    00154   return iFrames;
    00155 }

The documentation for this class was generated from the following file:

- Twang.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.